package cygxService

import (
	"errors"
	"hongze/hongze_mobile_admin/models/tables/company_contract"
	"hongze/hongze_mobile_admin/models/tables/cygx_company_user_type"
	"hongze/hongze_mobile_admin/services/alarm_msg"
	"hongze/hongze_mobile_admin/utils"
	"strconv"
	"time"
)

//func init() {
//	UpdateCygxCompanyUserType(708)
//}

// 处理权益客户身份类型(判断是否为大套餐客户)
func UpdateCygxCompanyUserType(companyApprovalId int) (err error) {
	defer func() {
		if err != nil {
			//fmt.Println(err)
			go alarm_msg.SendAlarmMsg("移动端，处理权益客户身份类型，判断是否为大套餐客户失败，Err："+err.Error()+"companyApprovalId:"+strconv.Itoa(companyApprovalId), 3)
		}
	}()
	permissionList, err := company_contract.GetCompanyContractPermissionListByContractId(companyApprovalId)
	if err != nil {
		err = errors.New("GetCompanyContractPermissionListByContractId，Err:" + err.Error())
	}
	var companyId int
	mappermissionName := make(map[string]int)
	for _, v := range permissionList {
		if v.IsUpgrade == 0 {
			mappermissionName[v.ChartPermissionName]++
		}
		companyId = v.CompanyId
	}
	//如果这些条件都满足那么就是大套餐客户
	if mappermissionName[utils.YI_YAO_NAME] == 2 && mappermissionName[utils.XIAO_FEI_NAME] == 2 && mappermissionName[utils.KE_JI_NAME] == 2 && mappermissionName[utils.ZHI_ZAO_NAME] == 2 && mappermissionName[utils.CE_LUE_NAME] == 1 && mappermissionName[utils.LU_YAN_FU_WU] == 1 {
		total, e := cygx_company_user_type.GetCygxCompanyUserTypeByCompanyId(companyId)
		if e != nil {
			err = errors.New("GetCygxCompanyUserTypeByCompanyId，Err:" + e.Error())
		}
		if total == 0 {
			item := new(cygx_company_user_type.CygxCompanyUserType)
			item.CompanyId = companyId
			item.CustomerTypeId = 2 // 大套餐客户类型定义为 2
			item.CreateTime = time.Now()
			item.ModifyTime = time.Now()
			e = cygx_company_user_type.AddCygxCompanyUserType(item)
		} else {
			e = cygx_company_user_type.UpdateCygxCompanyUserType(companyId, 2)
		}
		if e != nil {
			err = errors.New("GetCygxCompanyUserTypeByCompanyId，Err:" + e.Error())
		}
	} else {
		e := cygx_company_user_type.UpdateCygxCompanyUserType(companyId, 0)
		if e != nil {
			err = errors.New("UpdateCygxCompanyUserType，Err:" + e.Error())
		}
	}
	return
}
